//+------------------------------------------------------------------+
//|                                           Sample_iMAOnArray2.mq5 |
//|                               Copyright 2009, Fai Software Corp. |
//|                                    http://d.hatena.ne.jp/fai_fx/ |
//+------------------------------------------------------------------+
/*
How to use function like iMAOnArray.

// 1. add MovingAverages.mqh
#include <MovingAverages.mqh>

// 2. add MAonArrayBuffer in Grobal variable;
double         MAonArrayBuffer[];

// 3. Set ArraySetAsSeries in OnInit().
   ArraySetAsSeries(MAonArrayBuffer,true);

// 4. Resize Arraysize of MAonArrayBuffer in OnCalculate().
   ArrayResize(MAonArrayBuffer,Bars);
   
// 5. Call Simple/Exponential/LinearWeighted/SmoothedMAOnBuffer
   int ret=ExponentialMAOnBuffer(Bars,0,0,MAPeriod,OriginalBuffer,MAonArrayBuffer);
   
*/

#property copyright "2009, Fai Software Corp."
#property link      "http://d.hatena.ne.jp/fai_fx/"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1
//---- plot Original
#property indicator_label1  "Original"
#property indicator_type1   DRAW_LINE
#property indicator_color1  DeepPink
#property indicator_style1  STYLE_SOLID
#property indicator_width1  1

// 1. add MovingAverages.mqh
#include <MovingAverages.mqh>

//--- input parameters
input int      MAPeriod=5;
//--- indicator buffers
double         OriginalBuffer[];

// 2. add MAonArrayBuffer in Grobal variable;
double         MAonArrayBuffer[];
//
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,OriginalBuffer,INDICATOR_DATA);

// MQL4 Compatible
   ArraySetAsSeries(OriginalBuffer,true);
// 3. Set ArraySetAsSeries.
   ArraySetAsSeries(MAonArrayBuffer,true);

//---
   return(0);
  }
// MQL4 Compatible
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &Time[],
                const double &Open[],
                const double &High[],
                const double &Low[],
                const double &Close[],
                const long &Volume[],
                const long &Real_Volume[],
                const int &Spread[])
  {
//---
////////////////////////////////////////////////// 
// MQL4 Compatible
   ArraySetAsSeries(Open,true);
   ArraySetAsSeries(High,true);
   ArraySetAsSeries(Low,true);
   ArraySetAsSeries(Close,true);
   ArraySetAsSeries(Time,true);
   ArraySetAsSeries(Volume,true);
   ArraySetAsSeries(Spread,true);
   double Ask,Bid;
   Ask = SymbolInfoDouble(Symbol(),SYMBOL_ASK);
   Bid = SymbolInfoDouble(Symbol(),SYMBOL_BID);
   int Bars=rates_total;
   int IndicatorCounted=prev_calculated;
//////////////////////////////////////////////////  

   for(int i=Bars-1;i>=0;i--)
     {
      OriginalBuffer[i]=(High[i]+Low[i])/2.0;// Median Price..
     }
// 4. Resize Arraysize of MAonArrayBuffer
   ArrayResize(MAonArrayBuffer,Bars);

// MQL4  for (i = Bars-1; i >= 0; i--)
// MQL4      MAonArrayBuffer[i] = iMAOnArray(OriginalBuffer, 0, MAPeriod, 0, MODE_EMA, i); 
//
// 5. Call Simple/Exponential/LinearWeighted/SmoothedMAOnBuffer
   int ret=ExponentialMAOnBuffer(Bars,0,0,MAPeriod,OriginalBuffer,MAonArrayBuffer);



   for(int i=Bars-1;i>=0;i--)// THIS IS SAMPLE.:-)
     {
      OriginalBuffer[i]=MAonArrayBuffer[i];// EMA5 of Median Price.
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
